# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Compute
  module Models
    #
    # Describes Windows Configuration of the OS Profile.
    #
    class LinuxConfiguration

      include MsRestAzure

      # @return [Boolean] Gets or sets whether Authentication using user name
      # and password is allowed or not
      attr_accessor :disable_password_authentication

      # @return [SshConfiguration] Gets or sets the SSH configuration for
      # linux VMs
      attr_accessor :ssh

      #
      # Validate the object. Throws ValidationError if validation fails.
      #
      def validate
        @ssh.validate unless @ssh.nil?
      end

      #
      # Serializes given Model object into Ruby Hash.
      # @param object Model object to serialize.
      # @return [Hash] Serialized object in form of Ruby Hash.
      #
      def self.serialize_object(object)
        object.validate
        output_object = {}

        serialized_property = object.disable_password_authentication
        output_object['disablePasswordAuthentication'] = serialized_property unless serialized_property.nil?

        serialized_property = object.ssh
        unless serialized_property.nil?
          serialized_property = SshConfiguration.serialize_object(serialized_property)
        end
        output_object['ssh'] = serialized_property unless serialized_property.nil?

        output_object
      end

      #
      # Deserializes given Ruby Hash into Model object.
      # @param object [Hash] Ruby Hash object to deserialize.
      # @return [LinuxConfiguration] Deserialized object.
      #
      def self.deserialize_object(object)
        return if object.nil?
        output_object = LinuxConfiguration.new

        deserialized_property = object['disablePasswordAuthentication']
        output_object.disable_password_authentication = deserialized_property

        deserialized_property = object['ssh']
        unless deserialized_property.nil?
          deserialized_property = SshConfiguration.deserialize_object(deserialized_property)
        end
        output_object.ssh = deserialized_property

        output_object.validate

        output_object
      end
    end
  end
end
