# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Compute
  module Models
    #
    # Contains information about SSH certificate public key and the path on
    # the Linux VM where the public key is placed.
    #
    class SshPublicKey

      include MsRestAzure

      # @return [String] Gets or sets the full path on the created VM where
      # SSH public key is stored. If the file already exists, the specified
      # key is appended to the file.
      attr_accessor :path

      # @return [String] Gets or sets Certificate public key used to
      # authenticate with VM through SSH.The certificate must be in Pem
      # format with or without headers.
      attr_accessor :key_data

      #
      # Validate the object. Throws ValidationError if validation fails.
      #
      def validate
        # Nothing to validate
      end

      #
      # Serializes given Model object into Ruby Hash.
      # @param object Model object to serialize.
      # @return [Hash] Serialized object in form of Ruby Hash.
      #
      def self.serialize_object(object)
        object.validate
        output_object = {}

        serialized_property = object.path
        output_object['path'] = serialized_property unless serialized_property.nil?

        serialized_property = object.key_data
        output_object['keyData'] = serialized_property unless serialized_property.nil?

        output_object
      end

      #
      # Deserializes given Ruby Hash into Model object.
      # @param object [Hash] Ruby Hash object to deserialize.
      # @return [SshPublicKey] Deserialized object.
      #
      def self.deserialize_object(object)
        return if object.nil?
        output_object = SshPublicKey.new

        deserialized_property = object['path']
        output_object.path = deserialized_property

        deserialized_property = object['keyData']
        output_object.key_data = deserialized_property

        output_object.validate

        output_object
      end
    end
  end
end
